Loading...
Searching...
No Matches
branch_estimator.h
/*
* Software License Agreement (BSD License)
*
* Point Cloud Library (PCL) - www.pointclouds.org
* Copyright (c) 2010-2011, Willow Garage, Inc.
*
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* * Redistributions of source code must retain the above copyright
* notice, this list of conditions and the following disclaimer.
* * Redistributions in binary form must reproduce the above
* copyright notice, this list of conditions and the following
* disclaimer in the documentation and/or other materials provided
* with the distribution.
* * Neither the name of Willow Garage, Inc. nor the names of its
* contributors may be used to endorse or promote products derived
* from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
* FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
* COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
* ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*
*/
#pragma once
#include <pcl/common/common.h>
#include <pcl/common/utils.h> // pcl::utils::ignore
#include <pcl/ml/stats_estimator.h>
namespace pcl {
/** Interface for branch estimators. */
class PCL_EXPORTS BranchEstimator {
public:
/** Destructor. */
virtual ~BranchEstimator() = default;
/** Returns the number of branches the corresponding tree has. */
virtual std::size_t
getNumOfBranches() const = 0;
/** Computes the branch index for the specified result.
*
* \param[in] result the result the branch index will be computed for
* \param[in] flag the flag corresponding to the specified result
* \param[in] threshold the threshold used to compute the branch index
* \param[out] branch_index the destination for the computed branch index
*/
virtual void
computeBranchIndex(const float result,
const unsigned char flag,
const float threshold,
unsigned char& branch_index) const = 0;
};
/** Branch estimator for binary trees where the branch is computed only from the
* threshold. */
class PCL_EXPORTS BinaryTreeThresholdBasedBranchEstimator : public BranchEstimator {
public:
/** Constructor. */
inline BinaryTreeThresholdBasedBranchEstimator() = default;
/** Destructor. */
inline ~BinaryTreeThresholdBasedBranchEstimator() override = default;
/** Returns the number of branches the corresponding tree has. */
inline std::size_t
getNumOfBranches() const override
{
return 2;
}
/** Computes the branch index for the specified result.
*
* \param[in] result the result the branch index will be computed for
* \param[in] flag the flag corresponding to the specified result
* \param[in] threshold the threshold used to compute the branch index
* \param[out] branch_index the destination for the computed branch index
*/
inline void
computeBranchIndex(const float result,
const unsigned char flag,
const float threshold,
unsigned char& branch_index) const override
{
pcl::utils::ignore(flag);
branch_index = (result > threshold) ? 1 : 0;
}
};
/** Branch estimator for ternary trees where one branch is used for missing data
* (indicated by flag != 0). */
class PCL_EXPORTS TernaryTreeMissingDataBranchEstimator : public BranchEstimator {
public:
/** Constructor. */
inline TernaryTreeMissingDataBranchEstimator() = default;
/** Destructor. */
inline ~TernaryTreeMissingDataBranchEstimator() override = default;
/** \brief Returns the number of branches the corresponding tree has. */
inline std::size_t
getNumOfBranches() const override
{
return 3;
}
/** Computes the branch index for the specified result.
*
* \param[in] result the result the branch index will be computed for
* \param[in] flag the flag corresponding to the specified result
* \param[in] threshold the threshold used to compute the branch index
* \param[out] branch_index the destination for the computed branch index
*/
inline void
computeBranchIndex(const float result,
const unsigned char flag,
const float threshold,
unsigned char& branch_index) const override
{
if (flag == 0)
branch_index = (result > threshold) ? 1 : 0;
else
branch_index = 2;
}
};
} // namespace pcl
pcl::BinaryTreeThresholdBasedBranchEstimator
Branch estimator for binary trees where the branch is computed only from the threshold.
Definition branch_estimator.h:72
pcl::BinaryTreeThresholdBasedBranchEstimator::computeBranchIndex
void computeBranchIndex(const float result, const unsigned char flag, const float threshold, unsigned char &branch_index) const override
Computes the branch index for the specified result.
Definition branch_estimator.h:94
pcl::BinaryTreeThresholdBasedBranchEstimator::getNumOfBranches
std::size_t getNumOfBranches() const override
Returns the number of branches the corresponding tree has.
Definition branch_estimator.h:81
pcl::BinaryTreeThresholdBasedBranchEstimator::BinaryTreeThresholdBasedBranchEstimator
BinaryTreeThresholdBasedBranchEstimator()=default
Constructor.
pcl::BinaryTreeThresholdBasedBranchEstimator::~BinaryTreeThresholdBasedBranchEstimator
~BinaryTreeThresholdBasedBranchEstimator() override=default
Destructor.
pcl::BranchEstimator
Interface for branch estimators.
Definition branch_estimator.h:47
pcl::BranchEstimator::getNumOfBranches
virtual std::size_t getNumOfBranches() const =0
Returns the number of branches the corresponding tree has.
pcl::BranchEstimator::computeBranchIndex
virtual void computeBranchIndex(const float result, const unsigned char flag, const float threshold, unsigned char &branch_index) const =0
Computes the branch index for the specified result.
pcl::BranchEstimator::~BranchEstimator
virtual ~BranchEstimator()=default
Destructor.
pcl::TernaryTreeMissingDataBranchEstimator
Branch estimator for ternary trees where one branch is used for missing data (indicated by flag !...
Definition branch_estimator.h:106
pcl::TernaryTreeMissingDataBranchEstimator::getNumOfBranches
std::size_t getNumOfBranches() const override
Returns the number of branches the corresponding tree has.
Definition branch_estimator.h:115
pcl::TernaryTreeMissingDataBranchEstimator::TernaryTreeMissingDataBranchEstimator
TernaryTreeMissingDataBranchEstimator()=default
Constructor.
pcl::TernaryTreeMissingDataBranchEstimator::computeBranchIndex
void computeBranchIndex(const float result, const unsigned char flag, const float threshold, unsigned char &branch_index) const override
Computes the branch index for the specified result.
Definition branch_estimator.h:128
pcl::TernaryTreeMissingDataBranchEstimator::~TernaryTreeMissingDataBranchEstimator
~TernaryTreeMissingDataBranchEstimator() override=default
Destructor.
common.h
Define standard C methods and C++ classes that are common to all methods.
pcl::utils::ignore
void ignore(const T &...)
Utility function to eliminate unused variable warnings.
Definition utils.h:62
pcl
Definition convolution.h:46